"use strict";
this.name        = "towbarmissions";
this.author      = "Norby";
this.copyright   = "2013 Norbert Nagy";
this.licence     = "CC BY-NC-SA 3.0";
this.description = "Towing missions need towbar equipment and towing reputation.";

//internal properties, should not touch
this.$TowbarMissionActive = 0; //mission number during mission
this.$TowbarMissionED = 0; //mission ship arrived on escort deck
this.$TowbarMissionEDName = null; //name of mission ship for arrive on escort deck
this.$TowbarMissionNotNow = 0; //counter after a declined mission
this.$TowbarMissionShip = null; //mission target
this.$TowbarMissionSound = null; //success soundsource
this.$TowbarMissionsFCB = null; //rotate briefing ship
this.$TowbarMissionsShow = true; //show mission briefing
this.$TowbarMissionsTimer = null; //mission timer
this.$TowbarMissionsTimerC = 0; //mission timer counter

//world script events
this.startUp = function() {
	this.$TowbarMissionActive = missionVariables.$TowbarMissionActive;
        if( this.$TowbarMissionActive == 1 ) {
                missionVariables.$TowbarMission1 = 2; //failed, must not take a rest during the first mission
        }

	this.$TowbarMissionNotNow = missionVariables.$TowbarMissionNotNow;
	this.$TowbarMissionSound = new SoundSource;
	this.$TowbarMissionSound.sound = "towbarfireworks.ogg"; //sound of the success
	this.$TowbarMissionSound.loop = false;
	this.$TowbarMissionSound.repeatCount = 1;
}

this.missionScreenOpportunity = function() {
	var r = worldScripts["towbar"];
	if( this.$TowbarMissionNotNow > 0 ) this.$TowbarMissionNotNow--;
	if( player.ship.docked && player.ship.equipmentStatus("EQ_TOWBAR") == "EQUIPMENT_OK"
		&& this.$TowbarMissionsShow && this.$TowbarMissionNotNow <= 0 ) { //mission available?
		this.$TowbarMissionsShow = false; //show again after the next docking only
		var msg = "";
		var mi = 0;
		if( !missionVariables.$TowbarMission1 ) {
			var title = expandMissionText("towbar_mission1_title");
			var datakey = expandMissionText("towbar_mission1_datakey");
			msg = expandMissionText("towbar_mission1_text");
			mi = 1;
		}
		//todo: more mission briefings which need valid license
/*
		var ldate = 0;
		if( missionVariables.$TowbarLicenseDate > 0 ) ldate = missionVariables.$TowbarLicenseDate;
		if( ldate > 0 && clock.days > ldate + 365 && lcr >= r.$TowbarLicenseFee ) { //out of date
			lcr = 0; //must get new license in every year
			missionVariables.$TowbarLicense = 0;
			msg += "\nYour license is outdated, renew required.";
		}
*/		
		if( msg ) {
			mission.runScreen({
				title: title,
				message: msg,
				choices: {"_0" : "OK!","_1" : "Not now"},
				model: "["+datakey+"]",
				spinModel:false,
				background: r.$TowbarBG
			},function(choice) {
				if(choice == "_0") {
					if( mi == 1 ) missionVariables.$TowbarMission1 = 1; //started
					if( mi == 2 ) missionVariables.$TowbarMission2 = 1; //started
					if( mi == 3 ) missionVariables.$TowbarMission3 = 1; //started
					if( mi == 4 ) missionVariables.$TowbarMission4 = 1; //started
					if( mi == 5 ) missionVariables.$TowbarMission5 = 1; //started
					if( mi == 6 ) missionVariables.$TowbarMission6 = 1; //started
					if( mi == 7 ) missionVariables.$TowbarMission7 = 1; //started
					if( mi == 8 ) missionVariables.$TowbarMission8 = 1; //started
					if( mi == 9 ) missionVariables.$TowbarMission9 = 1; //started
					var pos = system.mainStation.position.add(system.mainStation.vectorForward.multiply(-20000 ));
					var a = system.addShips("["+datakey+"]", 1, pos, 500)[0];
					a.displayName+=": Help!";
                                        this.$TowbarMissionEDName = a.displayName;
					a.beaconCode="T";//Towing mission target
					a.setAI("nullAI.plist");
					a.awardEquipment("EQ_ESCAPE_POD");
					a.abandonShip(); //make derelict
					a.bounty=0;
					if( !a.script ) a.script = "oolite-default-ship-script.js";
					a.script.$TowbarMission = mi; //flag to this is a ship in mission 1
					a.script.$TowbarShipHealth = 1; //no losses during tow
					a.script.shipDied = worldScripts["towbarmissions"].$TowbarMissions_ShipDied1;//to detect 	failed
					this.$TowbarMissionShip = a;/*
		var ldate = 0;
		if( missionVariables.$TowbarLicenseDate > 0 ) ldate = missionVariables.$TowbarLicenseDate;
		if( ldate > 0 && clock.days > ldate + 365 && lcr >= r.$TowbarLicenseFee ) { //out of date
			lcr = 0; //must get new license in every year
			missionVariables.$TowbarLicense = 0;
			msg += "\nYour license is outdated, renew required.";
		}
*/		

					var i = expandMissionText("towbar_mission"+mi+"_short");
					mission.setInstructions( i, "towbarmissions" );//show in F5-F5 screen
					this.$TowbarMissionActive = mi;
					var wait = expandMissionText("towbar_mission"+mi+"_wait");
					if( wait && wait.length > 0) player.consoleMessage( wait, 10 );
				} else this.$TowbarMissionNotNow = 2; //show next time after 2 docking
				if( isValidFrameCallback( worldScripts["towbarmissions"].$TowbarMissionsFCB ) )
					removeFrameCallback( worldScripts["towbarmissions"].$TowbarMissionsFCB );
			});
			// camera is at [0,0,0] facing [1,0,0,0]
			mission.displayModel.position =Vector3D( mission.displayModel.position.x,
								 mission.displayModel.position.y,
								 1.7*mission.displayModel.position.z);
			if( !isValidFrameCallback( this.$TowbarMissionsFCB ) )
				this.$TowbarMissionsFCB = addFrameCallback( this.$TowbarMissions_FCB );
		}
	}
	if( this.$TowbarMissionActive && player.ship.docked ) {//todo: mission endings
		var msg = "";
		var sh = 0;
		if( this.$TowbarMissionActive == 1 ) { //mission 1 started
                        var arrived = false;
                        if( r.$TowbarShip && r.$TowbarShip.isValid && r.$TowbarShip.script
                                && r.$TowbarShip.script.$TowbarMission == 1 ) {
                                r.$TowbarShip.remove(true);
                                arrived = true;
                        } else if( this.$TowbarMissionED == this.$TowbarMissionActive ) {
                                this.$TowbarMissionED = 0;
                                arrived = true;  //mission ship arrived on escort deck
                        }
                        if( arrived ) { //mission1 target arrived
				this.$TowbarMissionSound.play(); //success sound
				missionVariables.$TowbarMission1 = -1; //ended with success
				sh = ++missionVariables.$TowbarShips; //salvager reputation
				r.$Towbar_UpdateReputation();
				player.score++;
				var p = 1 * expandMissionText("towbar_mission1_payout"); //force number
				if( p ) player.credits += p;
				var title = expandMissionText("towbar_mission1_end_title");
				var datakey = expandMissionText("towbar_mission1_datakey");
				msg = expandMissionText("towbar_mission1_end");
			} else if( missionVariables.$TowbarMission1 == 2 ) { //failed
				missionVariables.$TowbarMission1 = -2;//ended with fail
				var title = expandMissionText("towbar_mission1_fail_title");
				var datakey = expandMissionText("towbar_mission1_datakey");
				msg = expandMissionText("towbar_mission1_fail");
			}
		}
		//todo: more mission endings
		if( msg ) {
			if( sh > 0 ) msg+="\n\nThis is the "+sh+". ship in your salvager career.";
			var bk = worldScripts["towbar"].$TowbarBG;
			this.$TowbarMissionActive = 0;
			mission.setInstructions( null, "towbarmissions" );
			mission.runScreen({
				title: title,
				message: msg,
				choices: {"_0" : "OK"},
				model: "["+datakey+"]",
				spinModel:false,
				background: bk
			},function(choice) {
				if( isValidFrameCallback( worldScripts["towbarmissions"].$TowbarMissionsFCB ) )
					removeFrameCallback( worldScripts["towbarmissions"].$TowbarMissionsFCB );
			});
			// camera is at [0,0,0] facing [1,0,0,0]
			mission.displayModel.position =Vector3D( mission.displayModel.position.x,
								 mission.displayModel.position.y,
								 1.7*mission.displayModel.position.z);
			if( !isValidFrameCallback( this.$TowbarMissionsFCB ) )
				this.$TowbarMissionsFCB = addFrameCallback( this.$TowbarMissions_FCB2 );
		}
	}
}

this.playerStartedJumpCountdown = function(type, seconds) {
	if( this.$TowbarMissionActive == 1 ) {
// 		player.consoleMessage( "Oh no! We are in trouble, please do not jump out!", 5); - bogus: will show in all systems
	}
}

this.playerWillSaveGame = function(message) {
	missionVariables.$TowbarMissionActive = this.$TowbarMissionActive;
	missionVariables.$TowbarMissionNotNow = this.$TowbarMissionNotNow;
}

this.shipLaunchedFromStation = function() {
	if( this.$TowbarMissionActive > 0 ) {
		var wait = expandMissionText("towbar_mission"+this.$TowbarMissionActive+"_wait");
		if( wait && wait.length > 0) player.commsMessage( wait, 10 );

		if(this.$TowbarMissionsTimer) {
			this.$TowbarMissionsTimer.stop();
			delete this.$TowbarMissionsTimer;
		}
		this.$TowbarMissionsTimerC = 0;
		this.$TowbarMissionsTimer = new Timer(this, this.$TowbarMissions_Timed, 1, 1);
	}
}

this.shipWillDockWithStation = function() {
	this.$TowbarMissionsShow = true;
	if(this.$TowbarMissionsTimer) {
		this.$TowbarMissionsTimer.stop();
		delete this.$TowbarMissionsTimer;
	}
        if( this.$TowbarMissionActive > 0 ) { //mission started
				var e = worldScripts.escortdeck, m = this.$TowbarMissionShip;
				if (e) {
					for(var i = 0; i < e.$EscortDeckPadPos.length; i++ ) {
							var s = e.$EscortDeckShip[i];  //check mission ship on escort deck
							var d = e.$EscortDeckShipData[i];  //check mission ship in data array
							if( s && s.isValid && s.displayName === this.$TowbarMissionEDName
									|| d && d[0] && d[0][3] === this.$TowbarMissionEDName ) {
									this.$TowbarMissionED = this.$TowbarMissionActive; //found
									if(s && s.isValid) s.remove(true);
									e.$EscortDeckShip[i] = null;
									e.$EscortDeckShipData[i] = null;
							}
					}
				}
        }
}

this.shipWillEnterWitchspace = function() {
	if( this.$TowbarMissionActive == 1 ) this.$TowbarMissions_ShipDied1();
}

//TowbarMission methods
this.$TowbarMissions_FCB = function( delta ) { //FrameCallBack updating ship in briefings
	if( mission.displayModel && mission.displayModel.isValid ) { //as spinModel:true but zoomed out
		mission.displayModel.orientation = mission.displayModel.orientation.rotateY( delta );
		mission.displayModel.orientation = mission.displayModel.orientation.rotateX( delta );
	}
}

this.$TowbarMissions_FCB2 = function( delta ) { //FrameCallBack updating ship in endings
	if( mission.displayModel && mission.displayModel.isValid ) { //as in sell salvage screen but centered and zoomed out
		mission.displayModel.orientation = mission.displayModel.orientation.rotateY( delta );
	}
}

this.$TowbarMissions_Locked = function() { //when locked the towbar on a ship
	var ship = worldScripts["towbar"].$TowbarShip;
	var t = worldScripts["towbarmissions"];
	if( ship && ship.isValid && ship == t.$TowbarMissionShip ) {
		if( t.$TowbarMissionActive > 0 ) {
			var msg = expandMissionText("towbar_mission"+this.$TowbarMissionActive+"_locked");
			if( msg && msg.length > 0) player.commsMessage( msg, 10 );
			if(this.$TowbarMissionsTimer) {
				this.$TowbarMissionsTimer.stop(); //remove repeated message
				delete this.$TowbarMissionsTimer;
			}
		}
	}
}

this.$TowbarMissions_ShipDied1 = function(whom, why) {
	var i = expandMissionText("towbar_mission1_fail_short");
	mission.setInstructions( i, "towbarmissions" );
	player.consoleMessage( i, 10 );
	missionVariables.$TowbarMission1 = 2; //flag to failed
	if(this.$TowbarMissionsTimer) {
		this.$TowbarMissionsTimer.stop();
		delete this.$TowbarMissionsTimer;
	}
}

this.$TowbarMissions_Timed = function() {
	this.$TowbarMissionsTimerC++;
	if( this.$TowbarMissionActive > 0 ) {
		if( Math.floor( this.$TowbarMissionsTimerC / 120 ) == this.$TowbarMissionsTimerC / 120 ) {//at every 2 minutes
			var wait = expandMissionText("towbar_mission"+this.$TowbarMissionActive+"_wait");
			if( wait && wait.length > 0) player.consoleMessage( wait, 10 );
		}
	}
}
